diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index b9cacd461..9765a92d1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -973,19 +896,18 @@ public class WorldRenderer
         glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
         glAlphaFunc(516, 0.01F);
 
-        mc.textureManager.loadTexture(precipitation.getPrecipitationTexturePath(world.weatherManager.getWeatherPower(), world.weatherManager.getWeatherIntensity())).bind();
-        
-        double nextPosX = mc.activeCamera.getX(partialTick);
-        double nextPosY = mc.activeCamera.getY(partialTick);
-        double nextPosZ = mc.activeCamera.getZ(partialTick);
+        this.mc.textureManager.loadTexture(precipitation.getPrecipitationTexturePath(world.weatherManager.getWeatherPower(), world.weatherManager.getWeatherIntensity())).bind();
+
+        double nextPosX = this.mc.activeCamera.getX(partialTick);
+        double nextPosY = this.mc.activeCamera.getY(partialTick);
+        double nextPosZ = this.mc.activeCamera.getZ(partialTick);
         int floorPosY = MathHelper.floor(nextPosY);
         int radiusEffect = 10;
 
-        if (precipitation.getPrecipitationType() == IPrecipitation.Type.SNOW_LIKE)
-        {
-            for(int x = posX - radiusEffect; x <= posX + radiusEffect; x++) {
+        if (precipitation.getPrecipitationType() == IPrecipitation.Type.SNOW_LIKE) {
+            for (int x = posX - radiusEffect; x <= posX + radiusEffect; x++) {
                 blockedWeather:
-                for(int z = posZ - radiusEffect; z <= posZ + radiusEffect; z++) {
+                for (int z = posZ - radiusEffect; z <= posZ + radiusEffect; z++) {
                     int y = world.findTopSolidBlock(x, z);
                     Biome biomegenbase = world.getBlockBiome(x, y, z);
                     for (int q = 0; q < biomegenbase.blockedWeathers.length; q++) {
@@ -993,56 +915,54 @@ public class WorldRenderer
                             continue blockedWeather;
                         }
                     }
-                    if(y < 0) {
+                    if (y < 0) {
                         y = 0;
                     }
                     int i3 = y;
-                    if(i3 < floorPosY) {
+                    if (i3 < floorPosY) {
                         i3 = floorPosY;
                     }
                     int k3 = posY - radiusEffect;
                     int i4 = posY + radiusEffect;
-                    if(k3 < y) {
+                    if (k3 < y) {
                         k3 = y;
                     }
-                    if(i4 < y) {
+                    if (i4 < y) {
                         i4 = y;
                     }
                     float f3 = 1.0F;
-                    if(k3 != i4) {
-                        random.setSeed(x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abb + z * z * 0x66397 + z * 13761);
-                        float f5 = (float)rendererUpdateCount + partialTick;
-                        float f6 = ((float)(rendererUpdateCount & 0x1ff) + partialTick) / 512F;
-                        float f7 = random.nextFloat() + f5 * 0.01F * (float)random.nextGaussian();
-                        float f8 = random.nextFloat() + f5 * (float)random.nextGaussian() * 0.001F;
-                        double d5 = (double)((float)x + 0.5F) - mc.activeCamera.getX();
-                        double d6 = (double)((float)z + 0.5F) - mc.activeCamera.getZ();
-                        float f11 = MathHelper.sqrt(d5 * d5 + d6 * d6) / (float)radiusEffect;
+                    if (k3 != i4) {
+                        this.random.setSeed((long) x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abbL + (long) z * z * 0x66397 + z * 13761L);
+                        float f5 = (float) this.rendererUpdateCount + partialTick;
+                        float f6 = ((float) (this.rendererUpdateCount & 0x1ff) + partialTick) / 512F;
+                        float f7 = this.random.nextFloat() + f5 * 0.01F * (float) this.random.nextGaussian();
+                        float f8 = this.random.nextFloat() + f5 * (float) this.random.nextGaussian() * 0.001F;
+                        double d5 = (double) ((float) x + 0.5F) - this.mc.activeCamera.getX();
+                        double d6 = (double) ((float) z + 0.5F) - this.mc.activeCamera.getZ();
+                        float f11 = MathHelper.sqrt(d5 * d5 + d6 * d6) / (float) radiusEffect;
                         tessellator.startDrawingQuads();
                         float f12 = world.getLightBrightness(x, i3, z);
-                        if (mc.fullbright) f12 = 1.0f;
+                        if (this.mc.fullbright) f12 = 1.0f;
                         glColor4f(f12, f12, f12, ((1.0F - f11 * f11) * 0.3F + 0.5F) * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower());
-                        tessellator.setTranslation(-nextPosX * 1.0D, -nextPosY * 1.0D, -nextPosZ * 1.0D);
-                        tessellator.addVertexWithUV(x + 0, k3, (double)z + 0.5D, 0.0F * f3 + f7, ((float)k3 * f3) / 4F + f6 * f3 + f8);
-                        tessellator.addVertexWithUV(x + 1, k3, (double)z + 0.5D, 1.0F * f3 + f7, ((float)k3 * f3) / 4F + f6 * f3 + f8);
-                        tessellator.addVertexWithUV(x + 1, i4, (double)z + 0.5D, 1.0F * f3 + f7, ((float)i4 * f3) / 4F + f6 * f3 + f8);
-                        tessellator.addVertexWithUV(x + 0, i4, (double)z + 0.5D, 0.0F * f3 + f7, ((float)i4 * f3) / 4F + f6 * f3 + f8);
-                        tessellator.addVertexWithUV((double)x + 0.5D, k3, z + 0, 0.0F * f3 + f7, ((float)k3 * f3) / 4F + f6 * f3 + f8);
-                        tessellator.addVertexWithUV((double)x + 0.5D, k3, z + 1, 1.0F * f3 + f7, ((float)k3 * f3) / 4F + f6 * f3 + f8);
-                        tessellator.addVertexWithUV((double)x + 0.5D, i4, z + 1, 1.0F * f3 + f7, ((float)i4 * f3) / 4F + f6 * f3 + f8);
-                        tessellator.addVertexWithUV((double)x + 0.5D, i4, z + 0, 0.0F * f3 + f7, ((float)i4 * f3) / 4F + f6 * f3 + f8);
+                        tessellator.setTranslation(-nextPosX, -nextPosY, -nextPosZ);
+                        tessellator.addVertexWithUV(x, k3, (double) z + 0.5D, 0.0F * f3 + f7, ((float) k3 * f3) / 4F + f6 * f3 + f8);
+                        tessellator.addVertexWithUV(x + 1, k3, (double) z + 0.5D, f3 + f7, ((float) k3 * f3) / 4F + f6 * f3 + f8);
+                        tessellator.addVertexWithUV(x + 1, i4, (double) z + 0.5D, f3 + f7, ((float) i4 * f3) / 4F + f6 * f3 + f8);
+                        tessellator.addVertexWithUV(x, i4, (double) z + 0.5D, 0.0F * f3 + f7, ((float) i4 * f3) / 4F + f6 * f3 + f8);
+                        tessellator.addVertexWithUV((double) x + 0.5D, k3, z, 0.0F * f3 + f7, ((float) k3 * f3) / 4F + f6 * f3 + f8);
+                        tessellator.addVertexWithUV((double) x + 0.5D, k3, z + 1, f3 + f7, ((float) k3 * f3) / 4F + f6 * f3 + f8);
+                        tessellator.addVertexWithUV((double) x + 0.5D, i4, z + 1, f3 + f7, ((float) i4 * f3) / 4F + f6 * f3 + f8);
+                        tessellator.addVertexWithUV((double) x + 0.5D, i4, z, 0.0F * f3 + f7, ((float) i4 * f3) / 4F + f6 * f3 + f8);
                         tessellator.setTranslation(0.0D, 0.0D, 0.0D);
                         tessellator.draw();
                     }
                 }
 
             }
-        }
-        else if (precipitation.getPrecipitationType() == IPrecipitation.Type.RAIN_LIKE)
-        {
-            for(int x = posX - radiusEffect; x <= posX + radiusEffect; x++) {
+        } else if (precipitation.getPrecipitationType() == IPrecipitation.Type.RAIN_LIKE) {
+            for (int x = posX - radiusEffect; x <= posX + radiusEffect; x++) {
                 blockedWeather:
-                for(int z = posZ - radiusEffect; z <= posZ + radiusEffect; z++) {
+                for (int z = posZ - radiusEffect; z <= posZ + radiusEffect; z++) {
                     int y = world.findTopSolidBlock(x, z);
                     Biome biome = world.getBlockBiome(x, y, z);
                     for (int q = 0; q < biome.blockedWeathers.length; q++) {
@@ -1052,86 +972,77 @@ public class WorldRenderer
                     }
                     int j3 = posY - radiusEffect;
                     int l3 = posY + radiusEffect;
-                    if(j3 < y) {
+                    if (j3 < y) {
                         j3 = y;
                     }
-                    if(l3 < y) {
+                    if (l3 < y) {
                         l3 = y;
                     }
                     float f2 = 1.0F;
-                    if(j3 != l3) {
-                        random.setSeed(x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abb + z * z * 0x66397 + z * 13761);
-                        float f4 = (((float)(rendererUpdateCount + x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abb + z * z * 0x66397 + z * 13761 & 0x1f) + partialTick) / 32F) * (3F + random.nextFloat());
-                        double d3 = (double)((float)x + 0.5F) - mc.activeCamera.getX();
-                        double d4 = (double)((float)z + 0.5F) - mc.activeCamera.getZ();
-                        float f9 = MathHelper.sqrt(d3 * d3 + d4 * d4) / (float)radiusEffect;
+                    if (j3 != l3) {
+                        this.random.setSeed((long) x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abbL + (long) z * z * 0x66397 + z * 13761L);
+                        float f4 = (((float) (this.rendererUpdateCount + x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abb + z * z * 0x66397 + z * 13761 & 0x1f) + partialTick) / 32F) * (3F + this.random.nextFloat());
+                        double d3 = (double) ((float) x + 0.5F) - this.mc.activeCamera.getX();
+                        double d4 = (double) ((float) z + 0.5F) - this.mc.activeCamera.getZ();
+                        float f9 = MathHelper.sqrt(d3 * d3 + d4 * d4) / (float) radiusEffect;
                         tessellator.startDrawingQuads();
                         float f10 = world.getLightBrightness(x, world.getHeightBlocks(), z) * 0.85F + 0.15F;
-                        if (mc.fullbright) f10 = 1.0f;
+                        if (this.mc.fullbright) f10 = 1.0f;
                         glColor4f(f10, f10, f10, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.weatherManager.getWeatherIntensity() - 0.1f) * world.weatherManager.getWeatherPower());
-                        tessellator.setTranslation(-nextPosX * 1.0D, -nextPosY * 1.0D, -nextPosZ * 1.0D);
-                        tessellator.addVertexWithUV(x + 0, j3, (double)z + 0.5D, 0.0F * f2, ((float)j3 * f2) / 4F + f4 * f2);
-                        tessellator.addVertexWithUV(x + 1, j3, (double)z + 0.5D, 1.0F * f2, ((float)j3 * f2) / 4F + f4 * f2);
-                        tessellator.addVertexWithUV(x + 1, l3, (double)z + 0.5D, 1.0F * f2, ((float)l3 * f2) / 4F + f4 * f2);
-                        tessellator.addVertexWithUV(x + 0, l3, (double)z + 0.5D, 0.0F * f2, ((float)l3 * f2) / 4F + f4 * f2);
-                        tessellator.addVertexWithUV((double)x + 0.5D, j3, z + 0, 0.0F * f2, ((float)j3 * f2) / 4F + f4 * f2);
-                        tessellator.addVertexWithUV((double)x + 0.5D, j3, z + 1, 1.0F * f2, ((float)j3 * f2) / 4F + f4 * f2);
-                        tessellator.addVertexWithUV((double)x + 0.5D, l3, z + 1, 1.0F * f2, ((float)l3 * f2) / 4F + f4 * f2);
-                        tessellator.addVertexWithUV((double)x + 0.5D, l3, z + 0, 0.0F * f2, ((float)l3 * f2) / 4F + f4 * f2);
+                        tessellator.setTranslation(-nextPosX, -nextPosY, -nextPosZ);
+                        tessellator.addVertexWithUV(x, j3, (double) z + 0.5D, 0.0F * f2, ((float) j3 * f2) / 4F + f4 * f2);
+                        tessellator.addVertexWithUV(x + 1, j3, (double) z + 0.5D, f2, ((float) j3 * f2) / 4F + f4 * f2);
+                        tessellator.addVertexWithUV(x + 1, l3, (double) z + 0.5D, f2, ((float) l3 * f2) / 4F + f4 * f2);
+                        tessellator.addVertexWithUV(x, l3, (double) z + 0.5D, 0.0F * f2, ((float) l3 * f2) / 4F + f4 * f2);
+                        tessellator.addVertexWithUV((double) x + 0.5D, j3, z, 0.0F * f2, ((float) j3 * f2) / 4F + f4 * f2);
+                        tessellator.addVertexWithUV((double) x + 0.5D, j3, z + 1, f2, ((float) j3 * f2) / 4F + f4 * f2);
+                        tessellator.addVertexWithUV((double) x + 0.5D, l3, z + 1, f2, ((float) l3 * f2) / 4F + f4 * f2);
+                        tessellator.addVertexWithUV((double) x + 0.5D, l3, z, 0.0F * f2, ((float) l3 * f2) / 4F + f4 * f2);
                         tessellator.setTranslation(0.0D, 0.0D, 0.0D);
                         tessellator.draw();
                     }
                 }
 
             }
-        }
-        else if (precipitation.getPrecipitationType() == IPrecipitation.Type.INVERTED_RAIN_LIKE)
-        {
-            for(int x = posX - radiusEffect; x <= posX + radiusEffect; x++)
-            {
+        } else if (precipitation.getPrecipitationType() == IPrecipitation.Type.INVERTED_RAIN_LIKE) {
+            for (int x = posX - radiusEffect; x <= posX + radiusEffect; x++) {
                 blockedWeather:
-                for(int z = posZ - radiusEffect; z <= posZ + radiusEffect; z++)
-                {
+                for (int z = posZ - radiusEffect; z <= posZ + radiusEffect; z++) {
                     int topSolidY = world.findTopSolidBlock(x, z);
                     Biome biome = world.getBlockBiome(x, topSolidY, z);
-                    for (int i = 0; i < biome.blockedWeathers.length; i++)
-                    {
-                        if (biome.blockedWeathers[i] == weather)
-                        {
+                    for (int i = 0; i < biome.blockedWeathers.length; i++) {
+                        if (biome.blockedWeathers[i] == weather) {
                             continue blockedWeather;
                         }
                     }
                     int j3 = posY - radiusEffect;
                     int l3 = posY + radiusEffect;
-                    if(j3 < topSolidY)
-                    {
+                    if (j3 < topSolidY) {
                         j3 = topSolidY;
                     }
-                    if(l3 < topSolidY)
-                    {
+                    if (l3 < topSolidY) {
                         l3 = topSolidY;
                     }
                     float f2 = 1.0F;
-                    if(j3 != l3)
-                    {
-                        random.setSeed(x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abb + z * z * 0x66397 + z * 13761);
-                        float vOffset = (((float)(rendererUpdateCount + x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abb + z * z * 0x66397 + z * 13761 & 0x1f) + partialTick) / 32F) * (3F + random.nextFloat());
-                        double d3 = (double)((float)x + 0.5F) - mc.activeCamera.getX();
-                        double d4 = (double)((float)z + 0.5F) - mc.activeCamera.getZ();
-                        float f9 = MathHelper.sqrt(d3 * d3 + d4 * d4) / (float)radiusEffect;
+                    if (j3 != l3) {
+                        this.random.setSeed((long) x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abbL + (long) z * z * 0x66397 + z * 13761L);
+                        float vOffset = (((float) (this.rendererUpdateCount + x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abb + z * z * 0x66397 + z * 13761 & 0x1f) + partialTick) / 32F) * (3F + this.random.nextFloat());
+                        double d3 = (double) ((float) x + 0.5F) - this.mc.activeCamera.getX();
+                        double d4 = (double) ((float) z + 0.5F) - this.mc.activeCamera.getZ();
+                        float f9 = MathHelper.sqrt(d3 * d3 + d4 * d4) / (float) radiusEffect;
                         tessellator.startDrawingQuads();
                         float f10 = world.getLightBrightness(x, world.getHeightBlocks(), z) * 0.85F + 0.15F;
-                        if (mc.fullbright) f10 = 1.0f;
+                        if (this.mc.fullbright) f10 = 1.0f;
                         glColor4f(f10, f10, f10, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.weatherManager.getWeatherIntensity() - 0.1f) * world.weatherManager.getWeatherPower());
-                        tessellator.setTranslation(-nextPosX * 1.0D, -nextPosY * 1.0D, -nextPosZ * 1.0D);
-                        tessellator.addVertexWithUV(x + 0, j3, (double)z + 0.5D, 0.0F * f2, ((float)j3 * f2) / 4F - vOffset * f2);
-                        tessellator.addVertexWithUV(x + 1, j3, (double)z + 0.5D, 1.0F * f2, ((float)j3 * f2) / 4F - vOffset * f2);
-                        tessellator.addVertexWithUV(x + 1, l3, (double)z + 0.5D, 1.0F * f2, ((float)l3 * f2) / 4F - vOffset * f2);
-                        tessellator.addVertexWithUV(x + 0, l3, (double)z + 0.5D, 0.0F * f2, ((float)l3 * f2) / 4F - vOffset * f2);
-                        tessellator.addVertexWithUV((double)x + 0.5D, j3, z + 0, 0.0F * f2, ((float)j3 * f2) / 4F - vOffset * f2);
-                        tessellator.addVertexWithUV((double)x + 0.5D, j3, z + 1, 1.0F * f2, ((float)j3 * f2) / 4F - vOffset * f2);
-                        tessellator.addVertexWithUV((double)x + 0.5D, l3, z + 1, 1.0F * f2, ((float)l3 * f2) / 4F - vOffset * f2);
-                        tessellator.addVertexWithUV((double)x + 0.5D, l3, z + 0, 0.0F * f2, ((float)l3 * f2) / 4F - vOffset * f2);
+                        tessellator.setTranslation(-nextPosX, -nextPosY, -nextPosZ);
+                        tessellator.addVertexWithUV(x, j3, (double) z + 0.5D, 0.0F * f2, ((float) j3 * f2) / 4F - vOffset * f2);
+                        tessellator.addVertexWithUV(x + 1, j3, (double) z + 0.5D, f2, ((float) j3 * f2) / 4F - vOffset * f2);
+                        tessellator.addVertexWithUV(x + 1, l3, (double) z + 0.5D, f2, ((float) l3 * f2) / 4F - vOffset * f2);
+                        tessellator.addVertexWithUV(x, l3, (double) z + 0.5D, 0.0F * f2, ((float) l3 * f2) / 4F - vOffset * f2);
+                        tessellator.addVertexWithUV((double) x + 0.5D, j3, z, 0.0F * f2, ((float) j3 * f2) / 4F - vOffset * f2);
+                        tessellator.addVertexWithUV((double) x + 0.5D, j3, z + 1, f2, ((float) j3 * f2) / 4F - vOffset * f2);
+                        tessellator.addVertexWithUV((double) x + 0.5D, l3, z + 1, f2, ((float) l3 * f2) / 4F - vOffset * f2);
+                        tessellator.addVertexWithUV((double) x + 0.5D, l3, z, 0.0F * f2, ((float) l3 * f2) / 4F - vOffset * f2);
                         tessellator.setTranslation(0.0D, 0.0D, 0.0D);
                         tessellator.draw();
                     }
@@ -1146,12 +1057,11 @@ public class WorldRenderer
         glAlphaFunc(516, 0.1F);
     }
 
-    public void setupScaledResolution()
-    {
+    public void setupScaledResolution() {
         glClear(256);
         glMatrixMode(GL11.GL_PROJECTION);
         glLoadIdentity();
-        glOrtho(0.0D, mc.resolution.getExactScaledWidthScreenCoords(), mc.resolution.getExactScaledHeightScreenCoords(), 0.0D, 1000D, 3000D);
+        glOrtho(0.0D, this.mc.resolution.getExactScaledWidthScreenCoords(), this.mc.resolution.getExactScaledHeightScreenCoords(), 0.0D, 1000D, 3000D);
         glMatrixMode(GL11.GL_MODELVIEW);
         glLoadIdentity();
         glTranslatef(0.0F, 0.0F, -2000F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColor.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColor.java
index 1647148dd..b85d9562b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColor.java
@@ -1,10 +1,17 @@
 package net.minecraft.client.render.block.color;
 
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 
 public abstract class BlockColor
 {
     public abstract int getFallbackColor(int meta, int tintIndex);
 
-    public abstract int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex);
+    public abstract int getWorldColor(@NotNull WorldSource source, @NotNull TilePosc tilePos, int tintIndex);
+    @Deprecated
+    public final int getWorldColor(@NotNull WorldSource source, int x, int y, int z, int tintIndex) {
+        return getWorldColor(source, new TilePos(x, y, z), tintIndex);
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCrystal.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCrystal.java
index c14f23a9a..768ff8e96 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCrystal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCrystal.java
@@ -3,6 +3,8 @@ package net.minecraft.client.render.block.color;
 import net.minecraft.client.render.colorizer.Colorizer;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.noise.ImprovedNoise;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -13,7 +15,7 @@ public class BlockColorCrystal extends BlockColorCustom{
     }
     protected static ImprovedNoise crystalPerlinNoise = new ImprovedNoise(new Random(0));
     @Override
-    public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex) {
+    public int getWorldColor(@NotNull WorldSource source, @NotNull TilePosc tilePos, int tintIndex) {
 
         int color = 0xc40e26;
 //        float offsetR = (float) (crystalPerlinNoise.getValue(x / 10f, z / 10f)) * 0.5f;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCustom.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCustom.java
index a0a63f884..7a7787d57 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCustom.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCustom.java
@@ -2,27 +2,25 @@ package net.minecraft.client.render.block.color;
 
 import net.minecraft.client.render.colorizer.Colorizer;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockColorCustom extends BlockColor {
 
-	public Colorizer colorizer;
-	
-	public BlockColorCustom(Colorizer colorizer) {
-		this.colorizer = colorizer;
-		
-		if(colorizer == null) {
-			throw new NullPointerException();
-		}
-	}
-	
-	@Override
-	public int getFallbackColor(int meta, int tintIndex) {
-		return colorizer.getDefaultColor(1.0, 0.7);
-	}
+    public final @NotNull Colorizer colorizer;
 
-	@Override
-	public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex) {
-		return colorizer.getColor(world, x, y, z);
-	}
+    public BlockColorCustom(@NotNull Colorizer colorizer) {
+        this.colorizer = colorizer;
+    }
+
+    @Override
+    public int getFallbackColor(int meta, int tintIndex) {
+        return this.colorizer.getDefaultColor(1.0, 0.7);
+    }
+
+    @Override
+    public int getWorldColor(@NotNull WorldSource source, @NotNull TilePosc tilePos, int tintIndex) {
+        return this.colorizer.getColor(source, tilePos);
+    }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java
index daea781e4..8186f835c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.render.block.color;
 
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockColorDefault
     extends BlockColor
@@ -12,7 +14,7 @@ public class BlockColorDefault
     }
 
     @Override
-    public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex)
+    public int getWorldColor(@NotNull WorldSource source, @NotNull TilePosc tilePos, int tintIndex)
     {
         return 0xFFFFFF;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
index ab76b451c..4185895da 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
@@ -5,38 +5,40 @@ import java.util.Random;
 import net.minecraft.client.render.colorizer.Colorizer;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.noise.ImprovedNoise;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.Seasons;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockColorLeavesOak extends BlockColorCustom {
-	
-	private static ImprovedNoise fallColorPerlin = new ImprovedNoise(new Random(0));
-	
-	public BlockColorLeavesOak(Colorizer colorizer) {
-		super(colorizer);
-	}
-	
-	@Override
-	public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex) {
-		int color = super.getWorldColor(world, x, y, z, tintIndex);
-		
-		Season season = world.getSeasonManager().getCurrentSeason();
-		if(season != null) {
-			float progress = world.getSeasonManager().getSeasonProgress();
-			if(season == Seasons.OVERWORLD_FALL) {
-				float offsetIntensity = 1 - Math.abs((progress * 2) - 1);
-				float green = ((color & 0x00FF00) >> 8) / 255F;
-				float greenOffset = (float) fallColorPerlin.getValue(x / 10D, y / 10D, z / 10D) * offsetIntensity * 0.5f;
-				if(green + greenOffset > 0.8f)
-					greenOffset = 0.8f - green;
-				if(green + greenOffset < 0.0f)
-					greenOffset = -green;
-				int newGreen = ((int) ((green + greenOffset) * 255)) & 0xFF;
-				color &= 0xFF00FF;
-				color |= (newGreen << 8);
-			}
-		}
-		
-		return color;
-	}
+
+    private static final @NotNull ImprovedNoise fallColorPerlin = new ImprovedNoise(new Random(0));
+
+    public BlockColorLeavesOak(Colorizer colorizer) {
+        super(colorizer);
+    }
+
+    @Override
+    public int getWorldColor(@NotNull WorldSource source, @NotNull TilePosc tilePos, int tintIndex) {
+        int color = super.getWorldColor(source, tilePos, tintIndex);
+
+        Season season = source.getSeasonManager().getCurrentSeason();
+        if (season != null) {
+            float progress = source.getSeasonManager().getSeasonProgress();
+            if (season == Seasons.OVERWORLD_FALL) {
+                float offsetIntensity = 1 - Math.abs((progress * 2) - 1);
+                float green = ((color & 0x00FF00) >> 8) / 255F;
+                float greenOffset = (float) fallColorPerlin.getValue(tilePos.x() / 10D, tilePos.y() / 10D, tilePos.z() / 10D) * offsetIntensity * 0.5f;
+                if (green + greenOffset > 0.8f)
+                    greenOffset = 0.8f - green;
+                if (green + greenOffset < 0.0f)
+                    greenOffset = -green;
+                int newGreen = ((int) ((green + greenOffset) * 255)) & 0xFF;
+                color &= 0xFF00FF;
+                color |= (newGreen << 8);
+            }
+        }
+
+        return color;
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorPortal.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorPortal.java
index a854a0bd2..fd122ffd8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorPortal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorPortal.java
@@ -2,6 +2,8 @@ package net.minecraft.client.render.block.color;
 
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockColorPortal extends BlockColor{
     @Override
@@ -10,7 +12,7 @@ public class BlockColorPortal extends BlockColor{
     }
 
     @Override
-    public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex) {
-        return Colors.allPortalColors[(world.getBlockMetadata(x, y, z) >> 4) & 0xF].getARGB();
+    public int getWorldColor(@NotNull WorldSource source, @NotNull TilePosc tilePos, int tintIndex) {
+        return Colors.allPortalColors[(source.getBlockData(tilePos) >> 4) & 0xF].getARGB();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
index 14e018f9d..3222c3591 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
@@ -6,29 +6,31 @@ import net.minecraft.client.render.colorizer.Colorizer;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.noise.ImprovedNoise;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockColorTallGrass extends BlockColorCustom {
 	
 	protected static ImprovedNoise grassColorPerlin = new ImprovedNoise(new Random(0));
 	
-	public BlockColorTallGrass(Colorizer colorizer) {
+	public BlockColorTallGrass(@NotNull Colorizer colorizer) {
 		super(colorizer);
 	}
 	
 	@Override
-	public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex) {
+	public int getWorldColor(@NotNull WorldSource source, @NotNull TilePosc tilePos, int tintIndex) {
 
-		double localTemperature = world.getBlockTemperature(x, z);
-		double localHumidity = world.getBlockHumidity(x, z);
+		double localTemperature = source.getBlockTemperature(tilePos);
+		double localHumidity = source.getBlockHumidity(tilePos);
 
-		long l1 = x * 0x2fc20fL + z * 0x5d8875L + y;
+		long l1 = tilePos.x() * 0x2fc20fL + tilePos.z() * 0x5d8875L + tilePos.y();
 		l1 = l1 * l1 * 0x285b825L + l1 * 11L;
-		int xO = (int) ((long) x + (l1 >> 14 & 31L));
-		int yO = (int) ((long) y + (l1 >> 19 & 31L));
-		int zO = (int) ((long) z + (l1 >> 24 & 31L));
+		int xO = (int) ((long) tilePos.x() + (l1 >> 14 & 31L));
+		int yO = (int) ((long) tilePos.y() + (l1 >> 19 & 31L));
+		int zO = (int) ((long) tilePos.z() + (l1 >> 24 & 31L));
 
-		float offsetT = (float) grassColorPerlin.getValue(xO / 32D, yO / 32D, z / 32D) / 2.5F;
-		float offsetH = (float) grassColorPerlin.getValue(x / 32D, yO / 32D, zO / 32D) / 2.5F;
+		float offsetT = (float) grassColorPerlin.getValue(xO / 32D, yO / 32D, tilePos.z() / 32D) / 2.5F;
+		float offsetH = (float) grassColorPerlin.getValue(tilePos.x() / 32D, yO / 32D, zO / 32D) / 2.5F;
 
 		localTemperature += offsetT;
 		localHumidity += offsetH;
